Subject: Re: [Q/RFC] BPF use in broader scope

From: Li Yu <[email-masked]>
Date: Thu, 29 Mar 2012 17:49:18 +0800

于 2012年03月29日 15:44, Jiri Pirko 写道:
> Hi all.
>
> I came to an idea of using BPF infrastructure currently used in kernel,
> for computing hashes selecting TX ports in team device. Since the same
> data (skb) are alalyzed/used as for socket filtering, BPF seems so be quite
> suitable for this. It would allow userspace daemon to specify various
> kinds of TX selection algorithms.
>
> Here are proposed things to be done:
> 1) introduce in-kernel api for creating sk-unattached filters (I have
>     the patch cooked up already)
>
> 2) extend current BPF machine to allow XOR operation. Not sure if this
>     is doable or what the best of doing this is.
>
> 3) add possibility to pass some data to the machine via
>     pre-filling "Scratch Memory Store". I think this can be done easily
>     moving "u32 mem[BPF_MEMWORDS];" to bpf_func caller and pass it as the
>     second function parameter. That should not break anything.
>
> Then the computed hash can be either stored into Scratch memory or returned
> directly (where ordinary sk filters return len).
>
> Does this seems reasonable? Thoughts, comments?
>

Very interesting.

I am working on a blktrace like utility for networking subsystem. It
needs a trace events filter to avoid to generate too much results which
user does not interesting, it seem that the generic BPF is the best
choice here.

So far, the "skbtrace" need to filter two kinds of objects: the skb and 
socket, so I think that above "Scratch Memory Store" is necessary indeed.

Thanks.

Yu

> Thanks!
>
> Jirka
>
> --
> To unsubscribe from this list: send the line "unsubscribe netdev" in
> the body of a message to [email-masked]
> More majordomo info at  http://vger.kernel.org/majordomo-info.html
>